/* capricor.h */

/* definitions des registres d'emulation */


union regcapr
{
  unsigned char byt[72]; // added 8 extra bytes, to secure STM R60,R77 for instance (v1.1)
  struct sr {
    unsigned short ind;  // R0-1
    unsigned short idx;  // R2-3
    unsigned short pc;   // R4-5
    unsigned short sp;   // R6-R7
    unsigned short r[32];
  } reg;
};

GLOBAL union regcapr  regCPU;

GLOBAL unsigned char regARP, regDRP, regE, regFlags, regROMslt;
GLOBAL int lenDR;

GLOBAL int timerstat, compstat;  // timer and comparator status
GLOBAL unsigned long timer;   // timer value (fixed v1.2)
GLOBAL int  timer_l;
GLOBAL unsigned long tcomp;   // comparator value (fixed v1.2)
GLOBAL int  tcomp_l;

GLOBAL int fintr;   // GIE global interrupt enabled
GLOBAL int fwrom;   // ROM writable


GLOBAL unsigned char regLCD[34];  // physical LCD: 32 char + 2 announc. bytes
GLOBAL int regKey;  // physical key register (v1.1)

// POD (1.3): MEMIC internal registers:
GLOBAL int instmemic;   // installed MEMIC
GLOBAL int xmemsize;    // xmem file size in kB
GLOBAL char xmemfile[40];   // xmem file
GLOBAL unsigned short xmem_seg[8];  // 8x32kB = 256kB max
GLOBAL int podmemic;    // selected MEMIC
GLOBAL unsigned char podregA[4], podregB[4], podregC[4], podregD[4];
GLOBAL unsigned char podsts[4];


/* flags: (more and less in the order of SAD/PAD opcodes) */
#define m_MSB (1<<7)
#define m_LDZ (1<<6)
#define m_OVF (1<<5)
#define m_DCM (1<<4)
#define m_CY  (1<<3)
#define m_Z   (1<<2)
#define m_RDZ (1<<1)
#define m_LSB (1<<0)


/* table of memory segments */
GLOBAL unsigned short tab_seg[8];   // 8 segments of 8 kB


/* il devices */
GLOBAL int nbdev;  /* number of devices */
GLOBAL int tabdev[32];


/* temporary buffer (must be at least 1024 bytes) */
#define BUFSIZE 2048
GLOBAL unsigned char buffer[BUFSIZE];

